#include <bits/stdc++.h>
using namespace std;

int main() {
    ios_base::sync_with_stdio(0);
    cin.tie(0);
    cout.tie(0);

    int n,q,a[n];
    cin>>n>>q;
    for(long long i=0; i<n; i++){
        cin>>a[i];
    }
    for(long long i=0; i<q; i++){
        long long a,b,c;
        cin>>a>>b>>c;
        if((b-c)%2==0 && b%2==1){
            cout<<c-b+1<<endl;
        }
        else
        cout<<0<<endl;
    }
    
}
